=== debian/changelog ===
pftools (3.2.11-2) unstable; urgency=medium

  * Team Upload.
  * Revert "Add missing build dependency on dh addon."
  * Add patch to fix blhc
  * d/salsa-ci.yml:
    + Disable i386 build
    + Disable reprotest

 -- Nilesh Patra <nilesh@debian.org>  Tue, 25 Jan 2022 22:35:45 +0530

pftools (3.2.11-1) unstable; urgency=medium

  * Use Github tags instead of releases
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Tue, 25 Jan 2022 10:01:51 +0100

pftools (3.2.8-1) unstable; urgency=medium

  * Team Upload.
  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Drop patch applied upstream

  [ Nilesh Patra ]
  * d/rules:
    + Build without regex support
    + Remove test.sh command manual run
    + Install examples at right location
  * d/control: Remove B-D on libpcre2-dev (Closes: #1000002)
  * Tweak autopkgtest to get it working

 -- Nilesh Patra <nilesh@debian.org>  Tue, 25 Jan 2022 01:49:00 +0530
